// Transpose using shared

#version 450
#extension GL_ARB_compute_shader : enable
//#extension GL_ARB_shader_storage_buffer : enable
#define width 16
#define height 16

// Compute shader invocations in each work group

layout(std430, binding = 7) buffer bufc {float c[];};
//layout(std430, binding = 6) buffer bufb {float b[];};
layout(std430, binding = 5) buffer bufa {float a[];};
layout(local_size_x=width, local_size_y=height) in;

shared float s[width*height];

//Kernel Program
void main()
{
	uint theSizeX = gl_NumWorkGroups.x * gl_WorkGroupSize.x;
	uint theSizeY = gl_NumWorkGroups.y * gl_WorkGroupSize.y;

	int i = int(gl_GlobalInvocationID.y*theSizeX + gl_GlobalInvocationID.x);
	int j = int(gl_GlobalInvocationID.x*theSizeY + gl_GlobalInvocationID.y);
	int li = int(gl_LocalInvocationID.y*width + gl_LocalInvocationID.x);
	int lj = int(gl_LocalInvocationID.x*height + gl_LocalInvocationID.y);
	s[li] = a[i];
	
	barrier();
	
	c[i] = s[lj];
}

